#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "qcustomplot.h"
#include <QDebug>
#include "gev_camera.hpp"
#include "globalvar.h"

#ifdef _WIN64
#include "C:\lib\eigen\core\"
#elif _UNIX_
#include <Eigen/Core>
#include <Eigen/Dense>
#endif
#include <opencv2/highgui.hpp>
#include <opencv2/imgproc.hpp>
#include <QString>
#include <QFile>
#include <QDir>
#include <fstream>
#include <math.h>
#include <QMetaEnum>
#include <QVector>
#include <QTimer>
#include<QDebug>
#include<iostream>
#include <fstream>
#include <array>
#include <stdio.h>

#include <iomanip>
#include <thread>
#include <chrono>
#include <QImage>
#include <QLabel>
#include <QPixmap>

#include <vector>

#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
//#include "armadillo"
#include "src.h"
//#include <QSlider>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    setStyleSheet("");

    extern GEVCamera cameraFx10; //Fx10
    extern GEVCamera cameraFx17; //Fx17
    extern int record;

    system("sudo sysctl -w net.ipv6.conf.all.disable_ipv6=1");
    system("sudo sysctl -w net.ipv6.conf.default.disable_ipv6=1");
    system("source /home/scan/.bash_profile");
      QThread::sleep(1); // 1 second
    system("sudo ifconfig enp4s0 down");

    system("sudo rmmod e1000e");
    system("sudo /sbin/modprobe e1000e InterruptThrottleRate=1000 RxIntDelay=1024 RxDescriptors=4096");
    system("sudo ip link set enp4s0 address 8c:0f:6f:7a:67:c3");
    system("sudo ip link set enp4s0 mtu 9000");
    system("sudo ifconfig enp4s0 169.254.30.30 netmask 255.255.0.0 broadcast 0.0.0.0 up");

    using namespace Eigen;
    timer = new QTimer(this);
    using namespace Eigen;

    int nx = 25;
    int ny = cvrow10;

    // NOM DU REPERTOIRE DE STOCKAGE DES DONNEES PAR DEFAUT
    /*                     ***               ***    ***   ***   ***   *** */
    QString dirName="/home/scan/TEST1017"; // = QFileDialog::getExistingDirectory(this, tr("Open directory"));
    /*                  ***                 ***         ***         ***        */

    QDir dir1(dirName);
    dir1.setPath(dirName);
    dir1.setCurrent(QStringLiteral("/home/scan/TEST1017"));

    qDebug()<<   dir1.setCurrent(dirName);
    qDebug()<< dirName ;
    ui->dir2.setPath(dirName);
    qDebug()<< "Dir path = " << ui->dir2.absolutePath();
    ui->labelrepertoire->setText(dirName);

    m = Eigen::MatrixXf::Zero(nx,ny);

    setupRealtimeDataDemo(ui->customPlot);
    demoName = "Hyperspectral Data Viewer";
    setWindowTitle("Hyperscan : "+demoName);
    statusBar()->clearMessage();

}



/********************************************************************/
/*                                                                  */
/*                          mon_slot_slide                          */
/*                                                                  */
/********************************************************************/


void MainWindow::mon_slot_slide(const int lapos)
{
    //  qDebug()  << "mon_slot_slide " << QString::number(lapos) ;
}



/**************************************/
/* setupRealtimeDataDemo */
/**************************************/
// affichage waterfall
void MainWindow::setupRealtimeDataDemo(QCustomPlot *customPlot)
{

    demoName = "Hyperscan Software";

    ui->customPlot->addGraph(); // blue line
    ui->customPlot->graph(0)->setPen(QPen(QColor(40, 110, 255)));
    ui->customPlot->addGraph(); // red line
    ui->customPlot->graph(1)->setPen(QPen(QColor(255, 110, 40)));
    ui->customPlot->xAxis->setRange(0, 50);
    ui->customPlot->axisRect()->setupFullAxesBox();
    ui->customPlot->yAxis->setRange(0, cvrow10);

    // make left and bottom axes transfer their ranges to right and top axes:
    connect(ui->customPlot->xAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlot->xAxis2, SLOT(setRange(QCPRange)));
    connect(ui->customPlot->yAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlot->yAxis2, SLOT(setRange(QCPRange)));

    ui->customPlot->setInteractions(QCP::iRangeDrag|QCP::iRangeZoom); // this will also allow rescaling the color scale by dragging/zooming
    ui->customPlot->axisRect()->setupFullAxesBox(true);
    ui->customPlot->xAxis->setLabel("t");
    ui->customPlot->yAxis->setLabel("y");

    // set up the QCPColorMap:
    QCPColorMap *colorMap = new QCPColorMap(ui->customPlot->xAxis, ui->customPlot->yAxis);
    const  int nx = 25;
    int ny = cvrow10;

    colorMap->data()->setRange(QCPRange(0, 50), QCPRange(0, cvrow10));

    colorMap->data()->setSize(nx, ny); // we want the color map to have nx * ny data points
     // and span the coordinate range -4..4 in both key (x) and value (y) dimensions
    // now we assign some data, by accessing the QCPColorMapData instance of the color map:
    double x, y, z;
    for (int xIndex=0; xIndex<nx; ++xIndex)
    {
        for (int yIndex=0; yIndex<ny; ++yIndex)
        {
            colorMap->data()->cellToCoord(xIndex, yIndex, &x, &y);
            z=m.coeff(xIndex,yIndex);
            colorMap->data()->setCell(xIndex, yIndex, z);
        }
    }

    // add a color scale:
    QCPColorScale *colorScale = new QCPColorScale(ui->customPlot);
    ui->customPlot->plotLayout()->addElement(0, 1,colorScale); // add it to the right of the main axis rect
    colorScale->setType(QCPAxis::atRight); // scale shall be vertical bar with tick/axis labels right (actually atRight is already the default)
    colorMap->setColorScale(colorScale); // associate the color map with the color scale
    colorScale->axis()->setLabel("WaterFall Fx10");

    // set the color gradient of the color map to one of the presets:
    //colorMap->setGradient(QCPColorGradient::gpPolar); //gpPolar gpHot gpCold gpNight gpCandy gpGeogrphy gpIon gpThermal gpPolar gpSpectrum gpJet gpHues
    //colorMap->setGradient(QCPColorGradient::gpThermal);
    colorMap->setGradient(QCPColorGradient::gpPolar);
    // we could have also created a QCPColorGradient instance and added own colors to
    // the gradient, see the documentation of QCPColorGradient for what's possible.

    // rescale the data dimension (color) such that all data points lie in the span visualized by the color gradient:
    colorMap->rescaleDataRange();
    colorMap->setInterpolate(true); // true est meilleur
    // make sure the axis rect and color scale synchronize their bottom and top margins (so they line up):
    QCPMarginGroup *marginGroup = new QCPMarginGroup(ui->customPlot);
    ui->customPlot->axisRect()->setMarginGroup(QCP::msBottom|QCP::msTop, marginGroup);
    colorScale->setMarginGroup(QCP::msBottom|QCP::msTop, marginGroup);

    // rescale the key (x) and value (y) axes so the whole color map is visible:
    ui->customPlot->rescaleAxes();

    // setup a timer that repeatedly calls MainWindow::realtimeDataSlot:  // Pas besoin, on update a chaque getImage
    colorMap->rescaleDataRange(true);


} //Fin de setupRealtimeDataDemo


/**************************************/
/* NEWrealtimeDataSlot */
/**************************************/
// fonction pour waterfall
void MainWindow::NEWrealtimeDataSlot(const Eigen::MatrixXf &vec10)
{

    using namespace std;
    using namespace Eigen;
    int nx = 25;
    int ny = cvrow10;
    colorMap=qobject_cast<QCPColorMap*>(ui->customPlot->plottable(2));
    colorMap->rescaleDataRange(true);
    m.block(0,0,nx-1,cvrow10)=m.block(1,0,nx-1,cvrow10); // OK \o/
    m.block(nx-1,0,1,cvrow10)= vec10;//MatrixXf::Random(1,20);
    double z;
    for (int xIndex=0; xIndex<nx; ++xIndex)
    {
        for (int yIndex=0; yIndex<ny; ++yIndex)
        {
            z = m.coeff(xIndex,yIndex);
            colorMap->data()->setCell(xIndex, yIndex, z);
        }
    }

    ui->customPlot->replot();
} // Fin de  NEWrealtimeDataSlot




/**************************************/
/* AffichageSpectre */
/**************************************/

void MainWindow::AffichageSpectre(QCustomPlot *customPlotspectre,unsigned short yb[],unsigned short yv[],unsigned short yr[])
{

    ui->customPlotspectre->clearGraphs();
    ui->customPlotspectre->addGraph();
    QCPItemText *textLabel = new QCPItemText(customPlotspectre);
    demoName = "Simple Demo";
    QVector<double> x={397.01,	398.32,	399.63,	400.93,	402.24,	403.55,	404.86,	406.17,	407.48,	408.79,	410.10,	411.41,	412.72,	414.03,	415.34,	416.65,	417.96,	419.27,	420.58,	421.90,	423.21,	424.52,	425.83,	427.15,	428.46,	429.77,	431.09,	432.40,	433.71,	435.03,	436.34,	437.66,	438.97,	440.29,	441.60,	442.92,	444.23,	445.55,	446.87,	448.18,	449.50,	450.82,	452.13,	453.45,	454.77,	456.09,	457.40,	458.72,	460.04,	461.36,	462.68,	464.00,	465.32,	466.64,	467.96,	469.28,	470.60,	471.92,	473.24,	474.56,	475.88,	477.20,	478.52,	479.85,	481.17,	482.49,	483.81,	485.14,	486.46,	487.78,	489.11,	490.43,	491.75,	493.08,	494.40,	495.73,	497.05,	498.38,	499.70,	501.03,	502.35,	503.68,	505.01,	506.33,	507.66,	508.99,	510.31,	511.64,	512.97,	514.30,	515.63,	516.95,	518.28,	519.61,	520.94,	522.27,	523.60,	524.93,	526.26,	527.59,	528.92,	530.25,	531.58,	532.91,	534.25,	535.58,	536.91,	538.24,	539.57,	540.91,	542.24,	543.57,	544.90,	546.24,	547.57,	548.91,	550.24,	551.57,	552.91,	554.24,	555.58,	556.91,	558.25,	559.59,	560.92,	562.26,	563.59,	564.93,	566.27,	567.61,	568.94,	570.28,	571.62,	572.96,	574.30,	575.63,	576.97,	578.31,	579.65,	580.99,	582.33,	583.67,	585.01,	586.35,	587.69,	589.03,	590.37,	591.71,	593.06,	594.40,	595.74,	597.08,	598.42,	599.77,	601.11,	602.45,	603.80,	605.14,	606.48,	607.83,	609.17,	610.52,	611.86,	613.21,	614.55,	615.90,	617.24,	618.59,	619.94,	621.28,	622.63,	623.98,	625.32,	626.67,	628.02,	629.37,	630.71,	632.06,	633.41,	634.76,	636.11,	637.46,	638.81,	640.16,	641.51,	642.86,	644.21,	645.56,	646.91,	648.26,	649.61,	650.96,	652.31,	653.67,	655.02,	656.37,	657.72,	659.08,	660.43,	661.78,	663.14,	664.49,	665.84,	667.20,	668.55,	669.91,	671.26,	672.62,	673.97,	675.33,	676.68,	678.04,	679.40,	680.75,	682.11,	683.47,	684.82,	686.18,	687.54,	688.90,	690.25,	691.61,	692.97,	694.33,	695.69,	697.05,	698.41,	699.77,	701.13,	702.49,	703.85,	705.21,	706.57,	707.93,	709.29,	710.65,	712.02,	713.38,	714.74,	716.10,	717.47,	718.83,	720.19,	721.56,	722.92,	724.28,	725.65,	727.01,	728.38,	729.74,	731.11,	732.47,	733.84,	735.20,	736.57,	737.93,	739.30,	740.67,	742.03,	743.40,	744.77,	746.14,	747.50,	748.87,	750.24,	751.61,	752.98,	754.35,	755.72,	757.09,	758.46,	759.83,	761.20,	762.57,	763.94,	765.31,	766.68,	768.05,	769.42,	770.79,	772.17,	773.54,	774.91,	776.28,	777.66,	779.03,	780.40,	781.78,	783.15,	784.52,	785.90,	787.27,	788.65,	790.02,	791.40,	792.77,	794.15,	795.52,	796.90,	798.28,	799.65,	801.03,	802.41,	803.78,	805.16,	806.54,	807.92,	809.30,	810.67,	812.05,	813.43,	814.81,	816.19,	817.57,	818.95,	820.33,	821.71,	823.09,	824.47,	825.85,	827.23,	828.61,	830.00,	831.38,	832.76,	834.14,	835.53,	836.91,	838.29,	839.67,	841.06,	842.44,	843.83,	845.21,	846.59,	847.98,	849.36,	850.75,	852.13,	853.52,	854.91,	856.29,	857.68,	859.06,	860.45,	861.84,	863.23,	864.61,	866.00,	867.39,	868.78,	870.16,	871.55,	872.94,	874.33,	875.72,	877.11,	878.50,	879.89,	881.28,	882.67,	884.06,	885.45,	886.84,	888.23,	889.63,	891.02,	892.41,	893.80,	895.19,	896.59,	897.98,	899.37,	900.77,	902.16,	903.55,	904.95,	906.34,	907.74,	909.13,	910.53,	911.92,	913.32,	914.71,	916.11,	917.50,	918.90,	920.30,	921.69,	923.09,	924.49,	925.89,	927.28,	928.68,	930.08,	931.48,	932.88,	934.28,	935.68,	937.08,	938.48,	939.88,	941.28,	942.68,	944.08,	945.48,	946.88,	948.28,	949.68,	951.08,	952.48,	953.89,	955.29,	956.69,	958.09,	959.50,	960.90,	962.30,	963.71,	965.11,	966.52,	967.92,	969.33,	970.73,	972.14,	973.54,	974.95,	976.35,	977.76,	979.16,	980.57,	981.98,	983.38,	984.79,	986.20,	987.61,	989.02,	990.42,	991.83,	993.24,	994.65,	996.06,	997.47,	998.88,	1000.29,	1001.70,	1003.11,	1004.52	};
    QVector<double>  y0(cvcol10), y1(cvcol10), y2(cvcol10), y3(cvcol10);
    for (int i=0; i<cvcol10; ++i){
        y1[i] =(double) yb[i];
        y2[i] =(double) yv[i];
        y3[i] =(double) yr[i];
    }

    ui->customPlotspectre->graph(0)->setPen(QPen(Qt::red)); // line color blue for first graph
    ui->customPlotspectre->graph(0)->setBrush(QBrush(QColor(255, 0, 0, 20))); // first graph will be filled with translucent blue
    textLabel->setPositionAlignment(Qt::AlignTop|Qt::AlignHCenter);
    textLabel->position->setType(QCPItemPosition::ptAxisRectRatio);
    textLabel->position->setCoords(0.5, 0.01); // place position at center/top of axis rect
    textLabel->setText("Spectre non fiable");
    textLabel->setFont(QFont(font().family(), 13)); // make font a bit larger
    textLabel->setPen(QPen(Qt::red)); // show black border around text

    ui->customPlotspectre->graph(0)->setPen(QPen(Qt::blue)); // line color blue for first graph
    ui->customPlotspectre->clearItems();

    // placement de la légende
    ui->customPlotspectre->axisRect()->insetLayout()->setInsetAlignment(0, Qt::AlignTop|Qt::AlignRight);
    ui->customPlotspectre->xAxis2->setVisible(true);
    ui->customPlotspectre->xAxis2->setTickLabels(false);
    ui->customPlotspectre->yAxis2->setVisible(true);
    ui->customPlotspectre->yAxis2->setTickLabels(false);
    // make left and bottom axes always transfer their ranges to right and top axes:
    connect(ui->customPlotspectre->xAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotspectre->xAxis2, SLOT(setRange(QCPRange)));
    connect(ui->customPlotspectre->yAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotspectre->yAxis2, SLOT(setRange(QCPRange)));
    // pass data points to graphs:
    ui->customPlotspectre->graph(0)->setData(x, y1);
    ui->customPlotspectre->graph(0)->setName(QString("spectre pix101/1024"));
    ui->customPlotspectre->addGraph();
    ui->customPlotspectre->graph(1)->setPen(QPen(Qt::green)); // line color green for graph
    ui->customPlotspectre->graph(1)->setData(x, y2);
    ui->customPlotspectre->graph(1)->setName(QString("spectre pix512/1024"));
    ui->customPlotspectre->addGraph();
    ui->customPlotspectre->graph(2)->setPen(QPen(Qt::red)); // line color red for graph
    ui->customPlotspectre->graph(2)->setData(x, y3);
    ui->customPlotspectre->graph(2)->setName(QString("spectre pix700/1024"));

    // let the ranges scale themselves so graph 0 fits perfectly in the visible area:
    ui->customPlotspectre->graph(0)->rescaleAxes();
    ui->customPlotspectre->graph(1)->rescaleAxes(true);
    ui->customPlotspectre->graph(2)->rescaleAxes(true);
    ui->customPlotspectre->xAxis->setLabel("longueur d'onde (nm)");
    ui->customPlotspectre->yAxis->setLabel("amplitude (u.a.)");
    ui->customPlotspectre->legend->setVisible(true);
    ui->customPlotspectre->replot();
    ui->customPlotspectre->graph(0)->rescaleAxes();
    ui->customPlotspectre->rescaleAxes();
}



/**************************************/
/* AffichageSpectre17 */
/**************************************/

void MainWindow::AffichageSpectre17(QCustomPlot *customPlotspectre17,unsigned short yb[],unsigned short yv[],unsigned short yr[])
{

    ui->customPlotspectre17->clearGraphs();
    ui->customPlotspectre17->addGraph();
    QCPItemText *textLabel = new QCPItemText(customPlotspectre17);
    demoName = "Simple Demo";

    QVector<double> x={935.61, 	939.06, 	942.52, 	945.98, 	949.43, 	952.89, 	956.35, 	959.81, 	963.27, 	966.73, 	970.19, 	973.65, 	977.11, 	980.58, 	984.04, 	987.51, 	990.97, 	994.43, 	997.90, 	1001.37, 	1004.83, 	1008.30, 	1011.77, 	1015.24, 	1018.71, 	1022.18, 	1025.65, 	1029.12, 	1032.59, 	1036.06, 	1039.53, 	1043.00, 	1046.48, 	1049.95, 	1053.43, 	1056.90, 	1060.38, 	1063.85, 	1067.33, 	1070.81, 	1074.29, 	1077.76, 	1081.24, 	1084.72, 	1088.20, 	1091.68, 	1095.17, 	1098.65, 	1102.13, 	1105.61, 	1109.10, 	1112.58, 	1116.07, 	1119.55, 	1123.04, 	1126.52, 	1130.01, 	1133.50, 	1136.99, 	1140.47, 	1143.96, 	1147.45, 	1150.94, 	1154.43, 	1157.93, 	1161.42, 	1164.91, 	1168.40, 	1171.90, 	1175.39, 	1178.89, 	1182.38, 	1185.88, 	1189.37, 	1192.87, 	1196.37, 	1199.87, 	1203.37, 	1206.87, 	1210.37, 	1213.87, 	1217.37, 	1220.87, 	1224.37, 	1227.87, 	1231.38, 	1234.88, 	1238.39, 	1241.89, 	1245.40, 	1248.90, 	1252.41, 	1255.92, 	1259.42, 	1262.93, 	1266.44, 	1269.95, 	1273.46, 	1276.97, 	1280.48, 	1283.99, 	1287.51, 	1291.02, 	1294.53, 	1298.05, 	1301.56, 	1305.08, 	1308.59, 	1312.11, 	1315.62, 	1319.14, 	1322.66, 	1326.18, 	1329.70, 	1333.22, 	1336.74, 	1340.26, 	1343.78, 	1347.30, 	1350.82, 	1354.35, 	1357.87, 	1361.39, 	1364.92, 	1368.44, 	1371.97, 	1375.50, 	1379.02, 	1382.55, 	1386.08, 	1389.61, 	1393.14, 	1396.67, 	1400.20, 	1403.73, 	1407.26, 	1410.79, 	1414.32, 	1417.86, 	1421.39, 	1424.92, 	1428.46, 	1431.99, 	1435.53, 	1439.07, 	1442.60, 	1446.14, 	1449.68, 	1453.22, 	1456.76, 	1460.30, 	1463.84, 	1467.38, 	1470.92, 	1474.46, 	1478.01, 	1481.55, 	1485.09, 	1488.64, 	1492.18, 	1495.73, 	1499.27, 	1502.82, 	1506.37, 	1509.91, 	1513.46, 	1517.01, 	1520.56, 	1524.11, 	1527.66, 	1531.21, 	1534.76, 	1538.32, 	1541.87, 	1545.42, 	1548.98, 	1552.53, 	1556.09, 	1559.64, 	1563.20, 	1566.75, 	1570.31, 	1573.87, 	1577.43, 	1580.99, 	1584.55, 	1588.11, 	1591.67, 	1595.23, 	1598.79, 	1602.35, 	1605.92, 	1609.48, 	1613.04, 	1616.61, 	1620.17, 	1623.74, 	1627.31, 	1630.87, 	1634.44, 	1638.01, 	1641.58, 	1645.15, 	1648.71, 	1652.29, 	1655.86, 	1659.43, 	1663.00, 	1666.57, 	1670.14, 	1673.72, 	1677.29, 	1680.87, 	1684.44, 	1688.02, 	1691.59, 	1695.17, 	1698.75, 	1702.33, 	1705.91, 	1709.49, 	1713.07, 	1716.65, 	1720.23};
    QVector<double>  y0(cvcol17), y1(cvcol17), y2(cvcol17), y3(cvcol17);
    for (int i=0; i<cvcol17; ++i){
        y1[i] =(double) yb[i];
        y2[i] =(double) yv[i];
        y3[i] =(double) yr[i];
    }

    ui->customPlotspectre17->graph(0)->setPen(QPen(Qt::red)); // line color blue for first graph
    ui->customPlotspectre17->graph(0)->setBrush(QBrush(QColor(255, 0, 0, 20))); // first graph will be filled with translucent blue
    textLabel->setPositionAlignment(Qt::AlignTop|Qt::AlignHCenter);
    textLabel->position->setType(QCPItemPosition::ptAxisRectRatio);
    textLabel->position->setCoords(0.5, 0.01); // place position at center/top of axis rect
    textLabel->setText("Spectre non fiable");
    textLabel->setFont(QFont(font().family(), 13)); // make font a bit larger
    textLabel->setPen(QPen(Qt::red)); // show black border around text

    ui->customPlotspectre17->graph(0)->setPen(QPen(Qt::blue)); // line color blue for first graph
    ui->customPlotspectre17->clearItems();

    // placement de la légende
    ui->customPlotspectre17->axisRect()->insetLayout()->setInsetAlignment(0, Qt::AlignTop|Qt::AlignRight);
    ui->customPlotspectre17->xAxis2->setVisible(true);
    ui->customPlotspectre17->xAxis2->setTickLabels(false);
    ui->customPlotspectre17->yAxis2->setVisible(true);
    ui->customPlotspectre17->yAxis2->setTickLabels(false);
    // make left and bottom axes always transfer their ranges to right and top axes:
    connect(ui->customPlotspectre17->xAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotspectre17->xAxis2, SLOT(setRange(QCPRange)));
    connect(ui->customPlotspectre17->yAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotspectre17->yAxis2, SLOT(setRange(QCPRange)));
    // pass data points to graphs:
    ui->customPlotspectre17->graph(0)->setData(x, y1);
    ui->customPlotspectre17->graph(0)->setName(QString("spectre pix52/640"));
    ui->customPlotspectre17->addGraph();
    ui->customPlotspectre17->graph(1)->setPen(QPen(Qt::green)); // line color blue for first graph
    ui->customPlotspectre17->graph(1)->setData(x, y2);
    ui->customPlotspectre17->graph(1)->setName(QString("spectre pix320/640"));
    ui->customPlotspectre17->addGraph();
    ui->customPlotspectre17->graph(2)->setPen(QPen(Qt::red)); // line color blue for first graph
    ui->customPlotspectre17->graph(2)->setData(x, y3);
    ui->customPlotspectre17->graph(2)->setName(QString("spectre pix400/640"));
    ui->customPlotspectre17->graph(0)->rescaleAxes();
    ui->customPlotspectre17->graph(1)->rescaleAxes(true);
    ui->customPlotspectre17->graph(2)->rescaleAxes(true);
    ui->customPlotspectre17->xAxis->setLabel("longueur d'onde (nm)");
    ui->customPlotspectre17->yAxis->setLabel("amplitude (u.a.)");
    ui->customPlotspectre17->legend->setVisible(true);
    ui->customPlotspectre17->replot();
    ui->customPlotspectre17->graph(0)->rescaleAxes();
    ui->customPlotspectre17->rescaleAxes();
}


/**************************************/
/* AffichageSignal */
/**************************************/

void MainWindow::AffichageSignal(QCustomPlot *customPlotspectre,float yb[],float yv[],float yr[])
{

    int alerte=0;
    ui->customPlotspectre->clearGraphs();
    ui->customPlotspectre->addGraph();
    QCPItemText *textLabel = new QCPItemText(customPlotspectre);
    demoName = "Simple Demo";
    QVector<double> x(cvrow10);
    QVector<double>  y0(cvrow10), y1(cvrow10), y2(cvrow10), y3(cvrow10);
    for (int i=0; i<cvrow10; ++i){
        x[i]=i;
        y1[i] =(double) yb[i];
        y2[i] =(double) yv[i];
        y3[i] =(double) yr[i];
    }

    ui->customPlotspectre->graph(0)->setPen(QPen(Qt::red)); // line color blue for first graph
    ui->customPlotspectre->graph(0)->setBrush(QBrush(QColor(255, 0, 0, 20))); // first graph will be filled with translucent blue
    textLabel->setPositionAlignment(Qt::AlignTop|Qt::AlignHCenter);
    textLabel->position->setType(QCPItemPosition::ptAxisRectRatio);
    textLabel->position->setCoords(0.5, 0.01); // place position at center/top of axis rect
    textLabel->setText("Spectre non fiable");
    textLabel->setFont(QFont(font().family(), 13)); // make font a bit larger
    textLabel->setPen(QPen(Qt::red)); // show black border around text

    ui->customPlotspectre->graph(0)->setPen(QPen(Qt::blue)); // line color blue for first graph
    ui->customPlotspectre->clearItems();
    ui->customPlotspectre->axisRect()->insetLayout()->setInsetAlignment(0, Qt::AlignBottom|Qt::AlignRight);
    ui->customPlotspectre->graph(0)->setName("");
    ui->customPlotspectre->xAxis2->setVisible(true);
    ui->customPlotspectre->xAxis2->setTickLabels(false);
    ui->customPlotspectre->yAxis2->setVisible(true);
    ui->customPlotspectre->yAxis2->setTickLabels(false);
    // make left and bottom axes always transfer their ranges to right and top axes:
    connect(ui->customPlotspectre->xAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotspectre->xAxis2, SLOT(setRange(QCPRange)));
    connect(ui->customPlotspectre->yAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotspectre->yAxis2, SLOT(setRange(QCPRange)));
    // pass data points to graphs:
    ui->customPlotspectre->graph(0)->setData(x, y1);
    customPlotspectre->addGraph();
    ui->customPlotspectre->legend->setVisible(false);
    ui->customPlotspectre->graph(1)->setPen(QPen(Qt::green)); // line color green for graph
    ui->customPlotspectre->graph(1)->setData(x, y2);
    ui->customPlotspectre->legend->setVisible(false);
    customPlotspectre->addGraph();
    ui->customPlotspectre->graph(2)->setPen(QPen(Qt::red)); // line color red for graph
    ui->customPlotspectre->graph(2)->setData(x, y3);
    ui->customPlotspectre->legend->setVisible(false);
    ui->customPlotspectre->graph(0)->rescaleAxes();
    customPlotspectre->graph(1)->rescaleAxes(true);
    customPlotspectre->graph(2)->rescaleAxes(true);
    ui->customPlotspectre->xAxis->setLabel("longueur d'onde (nm)");
    ui->customPlotspectre->yAxis->setLabel("amplitude (u.a.)");
    ui->customPlotspectre->replot();
    ui->customPlotspectre->graph(0)->rescaleAxes();
    ui->customPlotspectre->rescaleAxes();
}





/**************************************/
/* closeshutter */
/**************************************/

void MainWindow::closeshutter(){

    cameraFx10.darkcurrent();
    cameraFx17.darkcurrent();
}


/**************************************/
/* openshutter */
/**************************************/

void MainWindow::openshutter(){
    cameraFx10.shutter_open();
    cameraFx17.shutter_open();
}



/**************************************/
/* BLANC */
/**************************************/

void MainWindow::blanc(){

    const QString StrBlanc="Blanc ";
    QString tempsblanc=QTime::currentTime().toString("HH_mm_ss");
    ui->pb_blanc->setText(StrBlanc);
    using namespace Eigen;
    using C3Stride = Stride<Dynamic, Dynamic>;
    using MatrixXfRowMajor  = Matrix<float, Dynamic, Dynamic, RowMajor>;
    using cvMapf = Map<MatrixXfRowMajor, Unaligned, C3Stride>;
    C3Stride c3Strided(cvcol10,1);
    C3Stride c3Strided17(cvcol17,1);
    ui->label2->clear();
    ui->label3->clear();
    ui->label4->clear();
    blancFx10=1;
    cptblanc=0;
    cv::Mat tempblanc10=cv::Mat::zeros(cvcol10,cvrow10, CV_32SC1);
    cv::Mat accu16blanc10=cv::Mat::zeros(cvcol10,cvrow10, CV_16UC1);
    cv::Mat tempblanc17=cv::Mat::zeros(cvcol10,cvrow17, CV_32SC1);
    cv::Mat accu16blanc17=cv::Mat::zeros(cvcol10,cvrow17, CV_16UC1);
    cv::Mat cvzeros(cvcol10,cvrow10,CV_32FC1);
    cvMapf sommeblanc10(reinterpret_cast<float *>(cvzeros.data),cvrow10,cvcol10,c3Strided);
    sommeblanc10.setZero();
    cv::Mat cvzeros17(cvcol17,cvrow17,CV_32FC1);
    cvMapf sommeblanc17(reinterpret_cast<float *>(cvzeros17.data),cvrow17,cvcol17,c3Strided17);
    sommeblanc10.setZero();

    QApplication::processEvents();

}


/**************************************/
/* DARkCURRENT */
/**************************************/

void MainWindow::darkcurrent()
{
    emit ui->pb_closeshutter->clicked();
    const QString StrDark="Dark ";
    ui->pb_dark_current->setText(StrDark);
    using namespace Eigen;
    using C3Stride = Stride<Dynamic, Dynamic>;
    using MatrixXfRowMajor  = Matrix<float, Dynamic, Dynamic, RowMajor>;
    using cvMapf = Map<MatrixXfRowMajor, Unaligned, C3Stride>;
    C3Stride c3Strided(cvcol10,1);
    C3Stride c3Strided17(cvcol17,1);
    ui->label3->clear();
    ui->label4->clear();
    darkFx10=1;
    cptdark=0;
    cv::Mat accu= cv::Mat::zeros(cvcol10,cvrow10, CV_32FC1);
    cv::Mat temp=cv::Mat::zeros(cvcol10,cvrow10, CV_32FC1);
    cv::Mat accu16=cv::Mat::zeros(cvcol10,cvrow10, CV_16UC1);
    cv::Mat cvzeros(cvcol10,cvrow10,CV_32FC1);
    cvMapf somme(reinterpret_cast<float *>(cvzeros.data),cvrow10,cvcol10,c3Strided);
    somme.setZero();
    cv::Mat accu17= cv::Mat::zeros(cvcol17,cvrow17, CV_32FC1);
    cv::Mat temp17=cv::Mat::zeros(cvcol17,cvrow17, CV_32FC1);
    cv::Mat accu1617=cv::Mat::zeros(cvcol17,cvrow17, CV_16UC1);
    cv::Mat cvzeros17(cvcol17,cvrow17,CV_32FC1);
    cvMapf somme17(reinterpret_cast<float *>(cvzeros17.data),cvrow17,cvcol17,c3Strided17);
    somme17.setZero();
}



/********************************************/
/* WEBCAM on_pushButton_open_webcam_clicked */
/********************************************/
void MainWindow::on_pushButton_open_webcam_clicked()
{
    //  cap.open(0); // 1= webcam integrée au portable HP (sinon 0 )
    cap.open(0);
    if(!cap.isOpened())  // Check if we succeeded
    {
        cout << "camera is not open" << endl;
    }
    else
    {
        cout << "camera is open" << endl;
        QTimer *ttt=new QTimer(this);
        CaptureHandler handler(&cap);
        handler.moveToThread(th);
        th->start();

        QObject::connect(ttt, SIGNAL(timeout()),this,SLOT(essai()));
        QObject::connect(this, SIGNAL(frameReady(QImage)),this, SLOT(update_window()));

        ttt->start(150); // temps de rafraichissement (plus élevé est mieux pour réactivité de l'application)

        QApplication::processEvents();
    }
    ui->pushButton_open_webcam->setEnabled(false);
}

/********************************************/
/* essai */
/********************************************/
// permet de récupérer le flux de la webcam en multi-threading
void  MainWindow::essai(){

    if (!cap.read(*original))
        return;
    QImage qimg((uchar*)original->data,original->cols,original->rows,original->step,QImage::Format_RGB888);
    emit frameReady(qimg);
}

/********************************************/
/* cleanup_mat */
/********************************************/
// supprime les variables utilisées
void MainWindow::cleanup_mat(void* info)
{
    delete (cv::Mat*)info;
}


/********************************************/
/* WEBCAM on_pushButton_close_webcam_clicked*/
/********************************************/
void MainWindow::on_pushButton_close_webcam_clicked()
{
    disconnect(this, SIGNAL(frameReady(QImage)),this, SLOT(update_window()));

    cap.release();

    Mat image = Mat::zeros(frame.size(),CV_8UC3);

    qt_image = QImage((const unsigned char*) (image.data), image.cols, image.rows, QImage::Format_RGB888);

    ui->label->setPixmap(QPixmap::fromImage(qt_image.scaled(150,100, Qt::IgnoreAspectRatio, Qt::FastTransformation)));

    ui->label->resize(ui->label->pixmap()->size());
    ui->pushButton_open_webcam->setEnabled(true);
    cout << "camera is closed" << endl;
}


/********************************************/
/* save_image                               */
/********************************************/

void MainWindow::save_image()
{
    vector<int> compression_params;
    QString filenamea=QDate::currentDate().toString("'IMG_'yyyy_MM_dd");
    QString filenameb=QTime::currentTime().toString("'-'HH_mm_ss'.png'");
    QString  filenameIMG=repertoire + QDir::separator()+filenamea+filenameb;
    std::string filenameIMGstd = filenameIMG.toLocal8Bit().constData();

    std::cout << filenameIMGstd << std::endl;

    cv::String cvIMGfile=filenameIMGstd;
    cv::cvtColor(frame, frame,cv::COLOR_BGR2RGB);
    frame.convertTo(img,CV_8UC3);
    bool bSuccess = imwrite(cvIMGfile,img, compression_params);
}




/**************************************/
/* UPDATE_WINDOW */
/**************************************/

void MainWindow::update_window()
{ // AFFICHE LA WEBCAM 
    cap >> frame;
    cv::cvtColor(frame, frame,cv::COLOR_BGR2RGB);
    frame.convertTo(img,CV_8UC3);
    QImage qimg(img.data,frame.cols*1,frame.rows*1,QImage::Format_RGB888);
    ui->label->setPixmap(QPixmap::fromImage(qimg.scaled(150,100,Qt::IgnoreAspectRatio,Qt::FastTransformation)));
    ui->label->resize(ui->label->pixmap()->size());
    QApplication::processEvents();


} // FIN de Update_window



/**************************************/
/* SCAN */
/**************************************/

void MainWindow::scan(){
    ui->customPlotscan17->setVisible(false);
    ui->customPlotscan->setVisible(false);
    ui->label4->setVisible(false);
    ui->label3->setVisible(false);

    record=1;
    debut_record=1;
    count10=0;
    count17=0;
    countmilieu10=0;
    countmilieu17=0;

    ui->pb_scan->setEnabled(false);
    ui->pb_stop_scan->setEnabled(true);
    ui->pb_dark_current->setEnabled(false);
    ui->pb_blanc->setEnabled(false);

    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> STOCKAGE= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(2000,cvrow10);
    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> STOCKAGE17= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(2000,cvrow17);

    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec10_512= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol10);
    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec17_320= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol17);
}




/******************************************/
/* stop_scan */
/******************************************/
// == STOP SCAN push_button
void MainWindow::stop_scan()
{

    try {
        fclose(foutapp10);
        fclose(foutapp17);
    } catch (errc aie) {
        std::cout << " ERREUR fermeture" << std::endl;
    }
    stopFx10=1;
    stopFx17=1;

   // qDebug() << count10;

    QString trame = QString::number(count10);
    ui->labeltrame->setText(trame);

    ui->customPlotscan->clearGraphs();
    ui->customPlotscan->clearPlottables();

    ui->customPlotscan->setInteractions(QCP::iRangeDrag|QCP::iRangeZoom); // this will also allow rescaling the color scale by dragging/zooming
    ui->customPlotscan->axisRect()->setupFullAxesBox(true);
    ui->customPlotscan->xAxis->setLabel("t");
    ui->customPlotscan->yAxis->setLabel("y");
    QCPColorMap *colorMap = new QCPColorMap(ui->customPlotscan->xAxis, ui->customPlotscan->yAxis);
    int nx = count10;
    int ny = cvrow10;
    ui->customPlotscan->setGeometry(QRect(1210, 60, nx, cvrow10/4));
    colorMap->data()->setRange(QCPRange(0, nx), QCPRange(0, cvrow10));
    colorMap->data()->setSize(nx, ny); // we want the color map to have nx * ny data points
    double x, y, z;
    for (int xIndex=0; xIndex<nx; ++xIndex)
    {
        for (int yIndex=0; yIndex<ny; ++yIndex)
        {
            colorMap->data()->cellToCoord(xIndex, yIndex, &x, &y);
            z=STOCKAGE.coeff(xIndex,yIndex);
            colorMap->data()->setCell(xIndex, yIndex, z);
        }
    }
     colorMap->setGradient(QCPColorGradient::gpPolar);
    colorMap->rescaleDataRange();
    colorMap->setInterpolate(true); // true est meilleur
    QCPMarginGroup *marginGroup = new QCPMarginGroup(ui->customPlotscan);
    ui->customPlotscan->axisRect()->setMarginGroup(QCP::msLeft|QCP::msRight, marginGroup);
    ui->customPlotscan->rescaleAxes();
    ui->customPlotscan->replot();
    ui->customPlotscan->setVisible(true);
    colorMap->rescaleDataRange(true);
    const QString  t10="img10scan.png";
    const QString file10=repertoire+ "/" + t10;
    ui->customPlotscan->savePng(file10);
    float marge10=ui->customPlotscan->yAxis->axisRect()->width();

    ui->customPlotscan17->clearGraphs();
    ui->customPlotscan17->clearPlottables();

    ui->customPlotscan17->setInteractions(QCP::iRangeDrag|QCP::iRangeZoom); // this will also allow rescaling the color scale by dragging/zooming
    ui->customPlotscan17->axisRect()->setupFullAxesBox(true);
    ui->customPlotscan17->xAxis->setLabel("t");
    ui->customPlotscan17->yAxis->setLabel("y");
    QCPColorMap *colorMap17 = new QCPColorMap(ui->customPlotscan17->xAxis, ui->customPlotscan17->yAxis);
    int nx17 = count10;
    int ny17 = cvrow17;
    ui->customPlotscan17->setGeometry(QRect(1210, 300, nx17, cvrow17/4));
    colorMap17->data()->setRange(QCPRange(0, nx17), QCPRange(0, cvrow17));

    colorMap17->data()->setSize(nx17, ny17); // we want the color map to have nx * ny data points
    double x17, y17, z17;
    for (int xIndex=0; xIndex<nx17; ++xIndex)
    {
        for (int yIndex=0; yIndex<ny17; ++yIndex)
        {
            colorMap17->data()->cellToCoord(xIndex, yIndex, &x17, &y17);
            z17=STOCKAGE17.coeff(xIndex,yIndex);
            colorMap17->data()->setCell(xIndex, yIndex, z17);
        }
    }
    colorMap17->setGradient(QCPColorGradient::gpPolar);
    colorMap17->rescaleDataRange();
    colorMap17->setInterpolate(true); // true est meilleur
    QCPMarginGroup *marginGroup17 = new QCPMarginGroup(ui->customPlotscan17);
    ui->customPlotscan17->axisRect()->setMarginGroup(QCP::msRight|QCP::msLeft, marginGroup);
    ui->customPlotscan17->rescaleAxes();
    ui->customPlotscan17->yAxis->axisRect()->setProperty("width",marge10);
    ui->customPlotscan17->replot();
    ui->customPlotscan17->setVisible(true);
    colorMap17->rescaleDataRange(true);
    const QString  t17="img17scan.png";
    const QString file17=repertoire+ "/" + t17;
    ui->customPlotscan17->savePng(file17);
    ui->customPlotscan17->rescaleAxes();

    // Spectre milieu10
    ui->customPlotmilieu10->clearGraphs();
    ui->customPlotmilieu10->addGraph();
    QCPItemText *textLabel = new QCPItemText(ui->customPlotmilieu10);
    QVector<double> x10={397.01,	398.32,	399.63,	400.93,	402.24,	403.55,	404.86,	406.17,	407.48,	408.79,	410.10,	411.41,	412.72,	414.03,	415.34,	416.65,	417.96,	419.27,	420.58,	421.90,	423.21,	424.52,	425.83,	427.15,	428.46,	429.77,	431.09,	432.40,	433.71,	435.03,	436.34,	437.66,	438.97,	440.29,	441.60,	442.92,	444.23,	445.55,	446.87,	448.18,	449.50,	450.82,	452.13,	453.45,	454.77,	456.09,	457.40,	458.72,	460.04,	461.36,	462.68,	464.00,	465.32,	466.64,	467.96,	469.28,	470.60,	471.92,	473.24,	474.56,	475.88,	477.20,	478.52,	479.85,	481.17,	482.49,	483.81,	485.14,	486.46,	487.78,	489.11,	490.43,	491.75,	493.08,	494.40,	495.73,	497.05,	498.38,	499.70,	501.03,	502.35,	503.68,	505.01,	506.33,	507.66,	508.99,	510.31,	511.64,	512.97,	514.30,	515.63,	516.95,	518.28,	519.61,	520.94,	522.27,	523.60,	524.93,	526.26,	527.59,	528.92,	530.25,	531.58,	532.91,	534.25,	535.58,	536.91,	538.24,	539.57,	540.91,	542.24,	543.57,	544.90,	546.24,	547.57,	548.91,	550.24,	551.57,	552.91,	554.24,	555.58,	556.91,	558.25,	559.59,	560.92,	562.26,	563.59,	564.93,	566.27,	567.61,	568.94,	570.28,	571.62,	572.96,	574.30,	575.63,	576.97,	578.31,	579.65,	580.99,	582.33,	583.67,	585.01,	586.35,	587.69,	589.03,	590.37,	591.71,	593.06,	594.40,	595.74,	597.08,	598.42,	599.77,	601.11,	602.45,	603.80,	605.14,	606.48,	607.83,	609.17,	610.52,	611.86,	613.21,	614.55,	615.90,	617.24,	618.59,	619.94,	621.28,	622.63,	623.98,	625.32,	626.67,	628.02,	629.37,	630.71,	632.06,	633.41,	634.76,	636.11,	637.46,	638.81,	640.16,	641.51,	642.86,	644.21,	645.56,	646.91,	648.26,	649.61,	650.96,	652.31,	653.67,	655.02,	656.37,	657.72,	659.08,	660.43,	661.78,	663.14,	664.49,	665.84,	667.20,	668.55,	669.91,	671.26,	672.62,	673.97,	675.33,	676.68,	678.04,	679.40,	680.75,	682.11,	683.47,	684.82,	686.18,	687.54,	688.90,	690.25,	691.61,	692.97,	694.33,	695.69,	697.05,	698.41,	699.77,	701.13,	702.49,	703.85,	705.21,	706.57,	707.93,	709.29,	710.65,	712.02,	713.38,	714.74,	716.10,	717.47,	718.83,	720.19,	721.56,	722.92,	724.28,	725.65,	727.01,	728.38,	729.74,	731.11,	732.47,	733.84,	735.20,	736.57,	737.93,	739.30,	740.67,	742.03,	743.40,	744.77,	746.14,	747.50,	748.87,	750.24,	751.61,	752.98,	754.35,	755.72,	757.09,	758.46,	759.83,	761.20,	762.57,	763.94,	765.31,	766.68,	768.05,	769.42,	770.79,	772.17,	773.54,	774.91,	776.28,	777.66,	779.03,	780.40,	781.78,	783.15,	784.52,	785.90,	787.27,	788.65,	790.02,	791.40,	792.77,	794.15,	795.52,	796.90,	798.28,	799.65,	801.03,	802.41,	803.78,	805.16,	806.54,	807.92,	809.30,	810.67,	812.05,	813.43,	814.81,	816.19,	817.57,	818.95,	820.33,	821.71,	823.09,	824.47,	825.85,	827.23,	828.61,	830.00,	831.38,	832.76,	834.14,	835.53,	836.91,	838.29,	839.67,	841.06,	842.44,	843.83,	845.21,	846.59,	847.98,	849.36,	850.75,	852.13,	853.52,	854.91,	856.29,	857.68,	859.06,	860.45,	861.84,	863.23,	864.61,	866.00,	867.39,	868.78,	870.16,	871.55,	872.94,	874.33,	875.72,	877.11,	878.50,	879.89,	881.28,	882.67,	884.06,	885.45,	886.84,	888.23,	889.63,	891.02,	892.41,	893.80,	895.19,	896.59,	897.98,	899.37,	900.77,	902.16,	903.55,	904.95,	906.34,	907.74,	909.13,	910.53,	911.92,	913.32,	914.71,	916.11,	917.50,	918.90,	920.30,	921.69,	923.09,	924.49,	925.89,	927.28,	928.68,	930.08,	931.48,	932.88,	934.28,	935.68,	937.08,	938.48,	939.88,	941.28,	942.68,	944.08,	945.48,	946.88,	948.28,	949.68,	951.08,	952.48,	953.89,	955.29,	956.69,	958.09,	959.50,	960.90,	962.30,	963.71,	965.11,	966.52,	967.92,	969.33,	970.73,	972.14,	973.54,	974.95,	976.35,	977.76,	979.16,	980.57,	981.98,	983.38,	984.79,	986.20,	987.61,	989.02,	990.42,	991.83,	993.24,	994.65,	996.06,	997.47,	998.88,	1000.29,	1001.70,	1003.11,	1004.52	};
    //qDebug() << "ligne 1104 countmilieu10=" << countmilieu10;
    QVector<double>  y0(cvcol10), y1(cvcol10), y2(cvcol10), y3(cvcol10);
    for (int i=0; i<cvcol10; ++i){
        y1[i] =(double) vec10_512(i)/countmilieu10;

    }
    ui->customPlotmilieu10->graph(0)->setBrush(QBrush(QColor(0,255, 0, 20))); // first graph will be filled with translucent blue
    ui->customPlotmilieu10->graph(0)->setPen(QPen(Qt::green)); // line color blue for first graph
    ui->customPlotmilieu10->clearItems();

    // placement de la légende
    ui->customPlotmilieu10->axisRect()->insetLayout()->setInsetAlignment(0, Qt::AlignTop|Qt::AlignRight);
    // configure right and top axis to show ticks but no labels:
    // (see QCPAxisRect::setupFullAxesBox for a quicker method to do this)
    ui->customPlotmilieu10->xAxis2->setVisible(true);
    ui->customPlotmilieu10->xAxis2->setTickLabels(false);
    ui->customPlotmilieu10->yAxis2->setVisible(true);
    ui->customPlotmilieu10->yAxis2->setTickLabels(false);
    // make left and bottom axes always transfer their ranges to right and top axes:
    connect(ui->customPlotmilieu10->xAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotmilieu10->xAxis2, SLOT(setRange(QCPRange)));
    connect(ui->customPlotmilieu10->yAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotmilieu10->yAxis2, SLOT(setRange(QCPRange)));
    // pass data points to graphs:
    ui->customPlotmilieu10->graph(0)->setData(x10, y1);
    ui->customPlotmilieu10->graph(0)->setName(QString("spectre moy pix512/1024"));
    // let the ranges scale themselves so graph 0 fits perfectly in the visible area:
    ui->customPlotmilieu10->graph(0)->rescaleAxes();
    ui->customPlotmilieu10->xAxis->setLabel("longueur d'onde (nm)");
    ui->customPlotmilieu10->yAxis->setLabel("amplitude (u.a.)");
    ui->customPlotmilieu10->legend->setVisible(true);
    ui->customPlotmilieu10->replot();
    ui->customPlotmilieu10->graph(0)->rescaleAxes();
    ui->customPlotmilieu10->rescaleAxes();

    const QString  spmilieu10="spmilieumoy10.png";
    const QString filemilieu10=repertoire+ "/" + spmilieu10;
    ui->customPlotmilieu10->savePng(filemilieu10);


    // Spectre  milieu17
    ui->customPlotmilieu17->clearGraphs();
    ui->customPlotmilieu17->addGraph();
    QVector<double> xx17={935.61, 	939.06, 	942.52, 	945.98, 	949.43, 	952.89, 	956.35, 	959.81, 	963.27, 	966.73, 	970.19, 	973.65, 	977.11, 	980.58, 	984.04, 	987.51, 	990.97, 	994.43, 	997.90, 	1001.37, 	1004.83, 	1008.30, 	1011.77, 	1015.24, 	1018.71, 	1022.18, 	1025.65, 	1029.12, 	1032.59, 	1036.06, 	1039.53, 	1043.00, 	1046.48, 	1049.95, 	1053.43, 	1056.90, 	1060.38, 	1063.85, 	1067.33, 	1070.81, 	1074.29, 	1077.76, 	1081.24, 	1084.72, 	1088.20, 	1091.68, 	1095.17, 	1098.65, 	1102.13, 	1105.61, 	1109.10, 	1112.58, 	1116.07, 	1119.55, 	1123.04, 	1126.52, 	1130.01, 	1133.50, 	1136.99, 	1140.47, 	1143.96, 	1147.45, 	1150.94, 	1154.43, 	1157.93, 	1161.42, 	1164.91, 	1168.40, 	1171.90, 	1175.39, 	1178.89, 	1182.38, 	1185.88, 	1189.37, 	1192.87, 	1196.37, 	1199.87, 	1203.37, 	1206.87, 	1210.37, 	1213.87, 	1217.37, 	1220.87, 	1224.37, 	1227.87, 	1231.38, 	1234.88, 	1238.39, 	1241.89, 	1245.40, 	1248.90, 	1252.41, 	1255.92, 	1259.42, 	1262.93, 	1266.44, 	1269.95, 	1273.46, 	1276.97, 	1280.48, 	1283.99, 	1287.51, 	1291.02, 	1294.53, 	1298.05, 	1301.56, 	1305.08, 	1308.59, 	1312.11, 	1315.62, 	1319.14, 	1322.66, 	1326.18, 	1329.70, 	1333.22, 	1336.74, 	1340.26, 	1343.78, 	1347.30, 	1350.82, 	1354.35, 	1357.87, 	1361.39, 	1364.92, 	1368.44, 	1371.97, 	1375.50, 	1379.02, 	1382.55, 	1386.08, 	1389.61, 	1393.14, 	1396.67, 	1400.20, 	1403.73, 	1407.26, 	1410.79, 	1414.32, 	1417.86, 	1421.39, 	1424.92, 	1428.46, 	1431.99, 	1435.53, 	1439.07, 	1442.60, 	1446.14, 	1449.68, 	1453.22, 	1456.76, 	1460.30, 	1463.84, 	1467.38, 	1470.92, 	1474.46, 	1478.01, 	1481.55, 	1485.09, 	1488.64, 	1492.18, 	1495.73, 	1499.27, 	1502.82, 	1506.37, 	1509.91, 	1513.46, 	1517.01, 	1520.56, 	1524.11, 	1527.66, 	1531.21, 	1534.76, 	1538.32, 	1541.87, 	1545.42, 	1548.98, 	1552.53, 	1556.09, 	1559.64, 	1563.20, 	1566.75, 	1570.31, 	1573.87, 	1577.43, 	1580.99, 	1584.55, 	1588.11, 	1591.67, 	1595.23, 	1598.79, 	1602.35, 	1605.92, 	1609.48, 	1613.04, 	1616.61, 	1620.17, 	1623.74, 	1627.31, 	1630.87, 	1634.44, 	1638.01, 	1641.58, 	1645.15, 	1648.71, 	1652.29, 	1655.86, 	1659.43, 	1663.00, 	1666.57, 	1670.14, 	1673.72, 	1677.29, 	1680.87, 	1684.44, 	1688.02, 	1691.59, 	1695.17, 	1698.75, 	1702.33, 	1705.91, 	1709.49, 	1713.07, 	1716.65, 	1720.23};
    qDebug() << "ligne 1173 countmilieu17=" << countmilieu17;
    QVector<double>  yy17(cvcol17);
    for (int i=0; i<cvcol17; ++i){
        yy17[i] =(double) vec17_320(i)/countmilieu17;
    }

    ui->customPlotmilieu17->graph(0)->setBrush(QBrush(QColor(0,255, 0, 20))); // first graph will be filled with translucent blue
    ui->customPlotmilieu17->graph(0)->setPen(QPen(Qt::green)); // line color blue for first graph
    ui->customPlotmilieu17->clearItems();

    // placement de la légende
    ui->customPlotmilieu17->axisRect()->insetLayout()->setInsetAlignment(0, Qt::AlignTop|Qt::AlignRight);
    // configure right and top axis to show ticks but no labels:
    // (see QCPAxisRect::setupFullAxesBox for a quicker method to do this)
    ui->customPlotmilieu17->xAxis2->setVisible(true);
    ui->customPlotmilieu17->xAxis2->setTickLabels(false);
    ui->customPlotmilieu17->yAxis2->setVisible(true);
    ui->customPlotmilieu17->yAxis2->setTickLabels(false);
    // make left and bottom axes always transfer their ranges to right and top axes:
    connect(ui->customPlotmilieu17->xAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotmilieu17->xAxis2, SLOT(setRange(QCPRange)));
    connect(ui->customPlotmilieu17->yAxis, SIGNAL(rangeChanged(QCPRange)), ui->customPlotmilieu17->yAxis2, SLOT(setRange(QCPRange)));
    // pass data points to graphs:
    ui->customPlotmilieu17->graph(0)->setData(xx17, yy17);
    ui->customPlotmilieu17->graph(0)->setName(QString("spectre moy pix320/640"));
    // let the ranges scale themselves so graph 0 fits perfectly in the visible area:
    ui->customPlotmilieu17->graph(0)->rescaleAxes();
    // same thing for graph 1, but only enlarge ranges (in case graph 1 is smaller than graph 0):
    // Note: we could have also just called customPlot->rescaleAxes(); instead
    // Allow user to drag axis ranges with mouse, zoom with mouse wheel and select graphs by clicking:
    ui->customPlotmilieu17->xAxis->setLabel("longueur d'onde (nm)");
    ui->customPlotmilieu17->yAxis->setLabel("amplitude (u.a.)");
    ui->customPlotmilieu17->legend->setVisible(true);
    ui->customPlotmilieu17->replot();
    ui->customPlotmilieu17->graph(0)->rescaleAxes();
    ui->customPlotmilieu17->rescaleAxes();

    const QString  spmilieu17="spmilieumoy17.png";
    const QString filemilieu17=repertoire+ "/" + spmilieu17;
    ui->customPlotmilieu17->savePng(filemilieu17);

    record=0;
    debut_record=0;
    count10=0;
    count17=0;

    if(stopFx10==1){  // toujours vrai
        qDebug() << "fin de stop scan";
        // Fin AFFICHAGE
        stopFx10=0;
        stopFx17=0;
      //  qDebug() << "fin 2 de stop scan";
        ui->pushButton_close_1017->setEnabled(true);
        ui->pb_dark_current->setEnabled(true);
        ui->pb_blanc->setEnabled(true);
        ui->pb_scan->setEnabled(true);
        ui->pb_stop_scan->setEnabled(false);
    }

    QApplication::processEvents();

} // fin de  stop_scan




/******************************************/
/* on_pushButton_close_1017_clicked() */
/******************************************/
// == STOP
void MainWindow::on_pushButton_close_1017_clicked()
{
    ui->pb_scan->setEnabled(false);
    ui->pb_stop_scan->setEnabled(false);
    ui->pb_dark_current->setEnabled(false);
    ui->pb_blanc->setEnabled(false);
    ui->pushButton_close_1017->setEnabled(false);
    if(stopFx10!=1){
        stopFx10=1;
        stopFx17=1;
        cameraFx10.stopstream();
        cameraFx17.stopstream();
       /* if (cameraFx10.threadPtr) {
            try{
                if  (cameraFx10.running){
                    //   cameraFx10.disconnect();
                }
                //  QApplication::processEvents();
            }
            catch (std::exception & e){ qFatal("Error %s sending event %s to object ", e.what());};
        }

        if (cameraFx17.threadPtr) {
            if  (cameraFx17.running){
                // cameraFx17.disconnect();
            }
        }
        */
        cameraFx10.disconnect();
        cameraFx17.disconnect();
        qDebug() << "cameraFx10.running=" <<   cameraFx10.running;
        qDebug() << "cameraFx17.running=" <<   cameraFx17.running;
        cameraFx10.threadPtr=nullptr;
        cameraFx17.threadPtr=nullptr;
    }
}  // fin de /* on_pushButton_close_1017_clicked() */
/******************************************/
// == STOP




/**************************************/
/* UPDATE_WINDOWBOTH */
/**************************************/
// fonction principale ()
void MainWindow::update_windowboth()
{
    ui->pushButton_close_1017->setEnabled(true);
    ui->pb_dark_current->setEnabled(true);
    ui->pb_blanc->setEnabled(true);
    ui->pb_scan->setEnabled(true);
    stopFx10=0;
    stopFx17=0;
    // Rappel : adresse MAC des caméras
    // GEVCamera camera("70:f8:e7:b0:01:6d"); //Fx10
    // GEVCamera camera("70:f8:e7:b0:01:33"); //Fx17

    using namespace Eigen;
    using C3Stride = Stride<Dynamic, Dynamic>;

    using MatrixXfRowMajor  = Matrix<float, Dynamic, Dynamic, RowMajor>;
    using cvMapf = Map<MatrixXfRowMajor, Unaligned, C3Stride>;

    C3Stride c3Strided(cvcol10,1);
    C3Stride c3Strided2(cvrow10,1);
    C3Stride c3Strided17(cvcol17,1);
    C3Stride c3Strided217(cvrow17,1);

    cameraFx10.running=true;
    cameraFx17.running=true;
    if  (!(cameraFx10.threadPtr)){
        cameraFx10.connect();
        cameraFx10.startstream();

        if ((cameraFx10.stream->IsOpen())==true) {
            qDebug() << "1353isopen " <<  " true" ;
        }
        else{
            qDebug() << "1353isopen " <<  " false" ;
        }
    }
    else{
        cameraFx10.startstream();

        if ((cameraFx10.stream->IsOpen())==true) {
            qDebug() << "1363isopen " <<  " true" ;
        }
        else{
            qDebug() << "1363isopen " <<  " false" ;
            cameraFx10.startstream();
        }

        if  (!(cameraFx10.stream->IsOpen())){
            cameraFx10.stream->Open(cameraFx10.deviceInfo);
        }
    }

    if  (!(cameraFx17.threadPtr)){
        cameraFx17.connect();
        cameraFx17.shutter_open();
        cameraFx17.startstream();
    }
    else{
        cameraFx17.startstream();
        if  (!(cameraFx17.stream->IsOpen())){
            cameraFx17.stream->Open(cameraFx10.deviceInfo);
        }

    }

    cv::Mat img10both;
    cv::Mat img17both;
    cv::Mat img10bothnorm;
    cv::Mat img10both8;
    cv::Mat accu10blanc8;
    cv::Mat accu108;
    cv::Mat accu17blanc8;
    cv::Mat accu178;


    cv::Mat cvzeros(cvcol10,cvrow10,CV_32FC1);
    cvMapf somme(reinterpret_cast<float *>(cvzeros.data),cvrow10,cvcol10,c3Strided);
    somme.setZero();

    cvMapf sommeblanc10(reinterpret_cast<float *>(cvzeros.data),cvrow10,cvcol10,c3Strided);
    sommeblanc10.setZero();

    cv::Mat cvzeros17(cvcol17,cvrow17,CV_32FC1);
    cvMapf somme17(reinterpret_cast<float *>(cvzeros17.data),cvrow17,cvcol17,c3Strided17);
    somme17.setZero();

    cvMapf sommeblanc17(reinterpret_cast<float *>(cvzeros17.data),cvrow17,cvcol17,c3Strided17);
    sommeblanc17.setZero();
    //qDebug()<< "ici 1369 " <<  stopFx10 <<  stopFx17;

    while(!stopFx10 && !stopFx17){
        // on fait tout en même temps (Fx10 et Fx17)
        if (stopFx10!=1){
            bool bOK=   cameraFx10.deviceInfo->IsConfigurationValid();
           // PvGenParameterArray *lDeviceParams =cameraFx10.stream->GetParameters();
            img10both = cameraFx10.getImage();
            img17both = cameraFx17.getImage();
            double minVal, maxVal;

            //----------------------------------------------------------------------------
            //------------------- DARK ---------------------------------------------------
            //----------------------------------------------------------------------------

            if (darkFx10==1){
                /* DÉBUT BOUCLE   */
                if ((darkFx10==1) & (cptdark<=NDARK)){ //c'était un while
                    if (cptdark==0){
                        cameraFx10.darkcurrent();
                        cameraFx17.darkcurrent();
                        QString filename0=ui->labelrepertoire->text();
                        QString filename1=QDate::currentDate().toString("'darkFx10_'yyyy_MM_dd");
                        QString filename2=QTime::currentTime().toString("'-'HH_mm_ss'.bin'");
                        QString filename=filename0+ QDir::separator()+filename1+filename2;
                        const char* filenamestd =filename.toLocal8Bit().constData();
                        // Sauvegarde Fichier binaire
                        foutddb=fopen(filenamestd,"a");
                        QString filenamed0=ui->labelrepertoire->text();
                        QString filenamed1=QDate::currentDate().toString("'darkFx17_'yyyy_MM_dd");
                        QString filenamed2=QTime::currentTime().toString("'-'HH_mm_ss'.bin'");
                        QString filenamed=filenamed0+ QDir::separator() + filenamed1+filenamed2;
                        const char* filenamestdd =filenamed.toLocal8Bit().constData();
                        // Sauvegarde Fichier binaire
                        foutddb17=fopen(filenamestdd,"a");
                        accu= cv::Mat::zeros(cvcol10,cvrow10, CV_32FC1); // CV_32SC1 initialisation à zéros de la marice déclarée globale
                        accu17= cv::Mat::zeros(cvcol17,cvrow17, CV_32FC1); // CV_32SC1 initialisation à zéros de la marice déclarée globale
                    }
                    else{ // cptdark>0
                        cv::Mat zaccu= cv::Mat::zeros(cvcol10,cvrow10, CV_32FC1);
                        cvMapf somme(reinterpret_cast<float *>(zaccu.data),cvrow10,cvcol10,c3Strided);
                        somme.setZero();

                        cv::Mat zaccu17= cv::Mat::zeros(cvcol17,cvrow17, CV_32FC1);
                        cvMapf somme17(reinterpret_cast<float *>(zaccu17.data),cvrow17,cvcol17,c3Strided17);
                        somme17.setZero();

                        img10both.convertTo(temp,CV_32FC1);

                        accu+=temp;
                        cvMapf maptemp(reinterpret_cast<float *>(temp.data),cvrow10,cvcol10,c3Strided);
                        somme+=maptemp;


                        img17both.convertTo(temp17,CV_32FC1);

                        accu17+=temp17;
                        cvMapf maptemp17(reinterpret_cast<float *>(temp17.data),cvrow17,cvcol17,c3Strided17);
                        somme17+=maptemp17;

                    }

                    if (cptdark>0){
                         // ecriture fichiers
                        //fwrite(temp.data,sizeof(unsigned short),cvcol10*cvrow10,foutddb); // mod
                      //  fwrite(temp17.data,sizeof(unsigned short),cvcol17*cvrow17,foutddb17); // mod
                        fwrite(img10both.data,sizeof(unsigned short),cvcol10*cvrow10,foutddb); // mod
                        fwrite(img17both.data,sizeof(unsigned short),cvcol17*cvrow17,foutddb17); // mod
                    }

                    if (cptdark==(NDARK)){
                        qDebug() << "FIN cptdark="  << cptdark;
                        fclose(foutddb);
                        fclose(foutddb17);
                        QApplication::processEvents(); // OUI
                        darkFx10=0;
                        cvMapf mapaccu(reinterpret_cast<float *>(accu.data),cvcol10,cvrow10,c3Strided2);//
                        accu.convertTo(accu,CV_32FC1,1./NDARK);  //Pour affichage spectre normalisé
                        accu17.convertTo(accu17,CV_32FC1,1./NDARK);   //Pour affichage spectre normalisé

                        cvMapf mapaccub(reinterpret_cast<float *>(accu.data),cvcol10,cvrow10,c3Strided2);//
                        const QString StrDark="Dark ";
                        QString tempsdark=QTime::currentTime().toString("HH:mm");
                        ui->pb_dark_current->setText(StrDark + tempsdark);

                        minMaxLoc(accu, &minVal, &maxVal);
                        accu.convertTo(accu108,CV_8UC1, 255.0/(maxVal - minVal), -minVal * 255.0/(maxVal - minVal));
                        qt_imaged = QImage((const unsigned char*) (accu108.data), accu16.cols, accu16.rows, QImage::Format_Grayscale8);
                        ui->label4->setPixmap(QPixmap::fromImage(qt_imaged.scaled(accu16.cols/2,accu16.rows/2, Qt::KeepAspectRatio, Qt::FastTransformation)));
                        ui->label4->resize(ui->label4->pixmap()->size());

                        minMaxLoc(accu17, &minVal, &maxVal);
                        accu17.convertTo(accu178,CV_8UC1, 255.0/(maxVal - minVal), -minVal * 255.0/(maxVal - minVal));
                        qt_imaged17 = QImage((const unsigned char*) (accu178.data), accu17.cols, accu17.rows, QImage::Format_Grayscale8);
                        ui->label3->setPixmap(QPixmap::fromImage(qt_imaged17.scaled(accu17.cols/1,accu17.rows/1, Qt::KeepAspectRatio, Qt::FastTransformation)));
                        ui->label3->resize(ui->label3->pixmap()->size());

                        cameraFx10.shutter_open();
                        cameraFx17.shutter_open();
                          QThread::sleep(1); // 1 second
                        cameraFx10.shutter_open(); // OUI ... (au cas où premier appel fail)
                    }

                    if (darkFx10==1){
                        cptdark++;
                    }
                }
                /* FIN BOUCLE   *///c'était un while

            } // Fin de  if (darkFx10==1) // On a fini le dark
            //----------------------------------------------------------------------------
            //------------------- Fin du dark --------------------------------------------
            //----------------------------------------------------------------------------


            //----------------------------------------------------------------------------
            //------------------- BLANC --------------------------------------------------
            //----------------------------------------------------------------------------

            if (blancFx10==1){
                /* DÉBUT BOUCLE   */
                if ((blancFx10==1) & (cptblanc10<=NBLANC10)){ //c'était un while
                    if (cptblanc10==0){
                       // qDebug() << "ici 1648";
                        cameraFx10.blanc(); // Ouverture shutter
                        cameraFx17.blanc(); // Ouverture shutter
                        QString filename0=ui->labelrepertoire->text();
                        QString filename1=QDate::currentDate().toString("'blancFx10_'yyyy_MM_dd");
                        QString filename2=QTime::currentTime().toString("'-'HH_mm_ss'.bin'");
                        QString filename=filename0+ QDir::separator()+filename1+filename2;
                        const char* filenamestd =filename.toLocal8Bit().constData();
                        foutddb=fopen(filenamestd,"a");
                        // Sauvegarde Fichier binaire
                        QString filenamed0=ui->labelrepertoire->text();
                        QString filenamed1=QDate::currentDate().toString("'blancFx17_'yyyy_MM_dd");
                        QString filenamed2=QTime::currentTime().toString("'-'HH_mm_ss'.bin'");
                        QString filenamed=filenamed0+ QDir::separator()+filenamed1+filenamed2;
                        const char* filenamestd17 =filenamed.toLocal8Bit().constData();
                        foutddb17=fopen(filenamestd17,"a");
                        // Sauvegarde Fichier binaire
                        accublanc10= cv::Mat::zeros(cvcol10,cvrow10, CV_32FC1); // CV_32SC1 initialisation à zéros de la marice déclarée globale
                        accublanc17= cv::Mat::zeros(cvcol17,cvrow17, CV_32FC1); // CV_32SC1 initialisation à zéros de la marice déclarée globale
                    }
                    else{ // cptblanc>0
                        cv::Mat zaccu= cv::Mat::zeros(cvcol10,cvrow10, CV_32FC1);
                        cvMapf sommeblanc10(reinterpret_cast<float *>(zaccu.data),cvrow10,cvcol10,c3Strided);
                        sommeblanc10.setZero();

                        cv::Mat zaccu17= cv::Mat::zeros(cvcol17,cvrow17, CV_32FC1);
                        cvMapf sommeblanc17(reinterpret_cast<float *>(zaccu17.data),cvrow17,cvcol17,c3Strided17);
                        sommeblanc17.setZero();

                        img10both.convertTo(tempblanc10,CV_32FC1);

                          // unsigned short dvect10b[cvcol10],dvect10v[cvcol10],dvect10r[cvcol10];
                       // for (int i=0;i<cvcol10;i++){
                        //    dvect10b[i]=tempblanc10.at<unsigned short>(i,101-1); //256
                        //    dvect10v[i]=tempblanc10.at<unsigned short>(i,512-1); //350
                        //    dvect10r[i]=tempblanc10.at<unsigned short>(i,700-1); //512
                       // }

                     //     AffichageSpectre(ui->customPlotspectre,dvect10b,dvect10v,dvect10r);


                        accublanc10+=tempblanc10;
                        cvMapf maptemp(reinterpret_cast<float *>(tempblanc10.data),cvrow10,cvcol10,c3Strided); //
                        sommeblanc10+=maptemp;

                        img17both.convertTo(tempblanc17,CV_32FC1);

                        accublanc17+=tempblanc17;
                        cvMapf maptemp17(reinterpret_cast<float *>(tempblanc17.data),cvrow17,cvcol17,c3Strided17); //
                        sommeblanc17+=maptemp17;
                    }


                    if (cptblanc10>0){
                        // ecriture fichier
                      //  fwrite(tempblanc10.data,sizeof(unsigned short),cvcol10*cvrow10,foutddb); // mod
                        fwrite(img10both.data,sizeof(unsigned short),cvcol10*cvrow10,foutddb); // mod
                        // ecriture fichier
                        //fwrite(tempblanc17.data,sizeof(unsigned short),cvcol17*cvrow17,foutddb17); // mod
                           fwrite(img17both.data,sizeof(unsigned short),cvcol17*cvrow17,foutddb17); // mod
                    }



                    if (cptblanc10==(NBLANC10)){
                        fclose(foutddb);
                        fclose(foutddb17);
                        QApplication::processEvents(); // OUI
                        blancFx10=0;
                        cptblanc10=0;
                        accublanc10.convertTo(accu16blanc10,CV_16UC1,1./NBLANC10);  //Pour affichage spectre normalisé
                        accublanc17.convertTo(accu16blanc17,CV_16UC1,1./NBLANC10);  //Pour affichage spectre normalisé
                        const QString StrBlanc="Blanc ";
                        QString tempsblanc=QTime::currentTime().toString("HH:mm");
                        ui->pb_blanc->setText(StrBlanc + tempsblanc);

                        minMaxLoc(accublanc10, &minVal, &maxVal);
                        accublanc10.convertTo(accu10blanc8,CV_8UC1, 255.0/(maxVal - minVal), -minVal * 255.0/(maxVal - minVal));

                        // L'affichaqe doit se faire sur 8 bits (Grayscale)
                        qt_imaged = QImage((const unsigned char*) (accu10blanc8.data), accu16blanc10.cols, accu16blanc10.rows, QImage::Format_Grayscale8);
                        ui->label4->setPixmap(QPixmap::fromImage(qt_imaged.scaled(accu16blanc10.cols/2,accu16blanc10.rows/2, Qt::KeepAspectRatio, Qt::FastTransformation)));
                        ui->label4->resize(ui->label4->pixmap()->size());
                        QApplication::processEvents(); //

                        minMaxLoc(accublanc17, &minVal, &maxVal);
                        accublanc17.convertTo(accu17blanc8,CV_8UC1, 255.0/(maxVal - minVal), -minVal * 255.0/(maxVal - minVal));
                        QApplication::processEvents(); //
                        // L'affichaqe doit se faire sur 8 bits (Grayscale)
                        qt_imaged17 = QImage((const unsigned char*) (accu17blanc8.data), accu16blanc17.cols, accu16blanc17.rows, QImage::Format_Grayscale8);
                        ui->label3->setPixmap(QPixmap::fromImage(qt_imaged17.scaled(accu16blanc17.cols/1,accu16blanc17.rows/1, Qt::KeepAspectRatio, Qt::FastTransformation)));
                        ui->label3->resize(ui->label3->pixmap()->size());
                        QApplication::processEvents(); //
                    }

                    if (blancFx10==1){
                        cptblanc10++;
                    }
                }
                /* FIN BOUCLE   */

            } // Fin de  if (blancFx10==1) // On a fini le blanc
            //----------------------------------------------------------------------------
            //------------------- Fin du blanc -------------------------------------------
            //----------------------------------------------------------------------------



            //----------------------------------------------------------------------------
            //------------------- AFFICHAGE ----------------------------------------------
            //----------------------------------------------------------------------------


            cv::Mat imgSP=img10both.clone();

            unsigned short dvect10b[cvcol10],dvect10v[cvcol10],dvect10r[cvcol10];
            for (int i=0;i<cvcol10;i++){
                dvect10b[i]=imgSP.at<unsigned short>(i,101-1); //256
                dvect10v[i]=imgSP.at<unsigned short>(i,512-1); //350
                dvect10r[i]=imgSP.at<unsigned short>(i,700-1); //512
            }

            cv::Mat imgSP17=img17both.clone();

            unsigned short dvect17b[cvcol17],dvect17v[cvcol17],dvect17r[cvcol17];
            for (int i=0;i<cvcol17;i++){
                dvect17b[i]=imgSP17.at<unsigned short>(i,52-1); //330
                dvect17v[i]=imgSP17.at<unsigned short>(i,320-1);//450
                dvect17r[i]=imgSP17.at<unsigned short>(i,400-1);//550
            }


            if((record!=1) && (blancFx10!=1) && (darkFx10!=1))  {
                /********************* AFFICHAGE SPECTRES ********************************/
                AffichageSpectre(ui->customPlotspectre,dvect10b,dvect10v,dvect10r);
                AffichageSpectre17(ui->customPlotspectre17,dvect17b,dvect17v,dvect17r);
                /********************* </AFFICHAGE SPECTRES> ********************************/
            }
            // Normalisation : img=(img-dark)/(blanc-dark);   img=  (img-accu)/(accublanc10-accu)
            img10both.convertTo(temp,CV_32FC1);

            minMaxLoc(img10both, &minVal, &maxVal);
            img10both.convertTo(img10both8,CV_8UC1, 255.0/(maxVal - minVal), -minVal * 255.0/(maxVal - minVal));
            double my_eps=1./1000000000;

            temp=(temp-accu);
            temp=temp/(accublanc10-accu+my_eps*0.0001);  // eps ?

            cv::minMaxLoc(temp, &minVal, &maxVal); //find minimum and maximum intensities
            // maxVal=280; //sinon on ne voit rien // NON
            cv::Mat img8bits(cvcol10,cvrow10,CV_8UC1);
            temp.convertTo(img8bits,CV_8UC1, 255.0/(maxVal - minVal), -minVal * 255.0/(maxVal - minVal));  //Amélioration contraste

            cv::Mat img10RAW=img10both.clone();
            img10RAW.convertTo(tempraw,CV_32FC1);

            cv::Mat img17RAW=img17both.clone();
            img17RAW.convertTo(temp17raw,CV_32FC1);

            img17both.convertTo(temp17,CV_32FC1);

            temp17=(temp17-accu17);
            temp17=temp17/(accublanc17-accu17+my_eps*0.0001);  // eps ?
            cvMapf mapaccu(reinterpret_cast<float *>(accu.data),cvcol10,cvrow10,c3Strided2);//   accu est le dark moyen
            cvMapf mapaccu17(reinterpret_cast<float *>(accu17.data),cvcol17,cvrow17,c3Strided2);//

            if(record!=1){
                cvMapf maptemp(reinterpret_cast<float *>(temp.data),cvcol10,cvrow10,c3Strided2);//
                MatrixXf vec10e;//= Eigen::MatrixXf::Zero(cvrow10,1);//
                vec10e=maptemp.colwise().maxCoeff();//  On veut le signal al a frequence 100, le stocquer dans une matrice quand record=1 puis affichage
                /********************* AFFICHAGE WATERFALL ********************************/
                NEWrealtimeDataSlot(vec10e);//
                /********************* </AFFICHAGE WTERFALL> ********************************/
            }
            else{
                if (count10>=1) {// if (debut_record!=1) {
                    // quelle est la difference entre maptemp et maptemraw  (e.g. temp et tempraw) ? -> normalisation (dark et blanc) pour temp pas pour tempraw
                    cvMapf maptemp(reinterpret_cast<float *>(temp.data),cvcol10,cvrow10,c3Strided2);//
                    cvMapf maptempraw(reinterpret_cast<float *>(tempraw.data),cvcol10,cvrow10,c3Strided2);//
                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec10_100= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvrow10);
                    vec10_100=maptemp.row(100).cast<float>();  // 101 eme longueur d'onde == 528.92 nm

                    // on cherche les spectre viande au milieu du tapis
                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec10_512tmp= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol10);
                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec10_512tmpraw= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol10);

                    vec10_512tmp=maptemp.col(512-1).cast<float>().transpose();
                    vec10_512tmpraw=maptempraw.col(512-1).cast<float>().transpose();

                    // ZONE DE TRAVAIL !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

                    if (count10<NDARK) {//     On va accumuler du spectre de tapis sur les NDARK=100 premieres iterations
                        vec10_512tmprawtapis+=vec10_512tmpraw;
                    }
                    else{
                        util10=(vec10_512tmprawtapis/NDARK)-vec10_512tmpraw;
                        util10=util10.array().abs();

                        if ((vec10_512tmpraw.maxCoeff()>=1.2*mapaccu.col(512-1).mean())  && (util10.maxCoeff()>8) ){
                            vec10_512+= vec10_512tmp;
                            countmilieu10++;
                        }
                    }
                    STOCKAGE.row(count10)=vec10_100.cast<float>();


                    cvMapf maptemp17(reinterpret_cast<float *>(temp17.data),cvcol17,cvrow17,c3Strided217);//
                    cvMapf maptemp17raw(reinterpret_cast<float *>(temp17raw.data),cvcol17,cvrow17,c3Strided217);//
                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec17_100= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvrow17);
                    vec17_100=maptemp17.row(101).cast<float>(); // 101 eme longueur d'onde ==1283.99 nm

                    // on cherche les spectre viande au milieu du tapis
                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec17_320tmp= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol17);
                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec17_320tmpraw= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol17);

                    vec17_320tmp=maptemp17.col(320-1).cast<float>().transpose();
                    vec17_320tmpraw=maptemp17raw.col(320-1).cast<float>().transpose();


                    if (count10<NDARK) {//     On va accumuler du spectre de tapis sur les NDARK=100 premieres iterations
                        vec17_320tmprawtapis+=vec17_320tmpraw;
                    }
                    else{
                        util17=(vec17_320tmprawtapis/NDARK)-vec17_320tmpraw;
                        util17=util17.array().abs();
                        if ((vec17_320tmpraw.maxCoeff()>=1.2*mapaccu17.col(320-1).mean())  && (util17.maxCoeff()>8)   ){
                            vec17_320+= vec17_320tmp;
                            countmilieu17++;
                        }
                    }
                    STOCKAGE17.row(count10)=vec17_100.cast<float>();
                }
                else{ // i.e debut _record==1
                    cvMapf mapaccu(reinterpret_cast<float *>(accu.data),cvcol10,cvrow10,c3Strided2);//
                    cvMapf mapaccu17(reinterpret_cast<float *>(accu17.data),cvcol17,cvrow17,c3Strided217);//

                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec10_512tmprawtapis= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol10);
                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> util10= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol10);

                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> vec17_320tmprawtapis= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol17);
                    Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> util17= Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic>::Zero(1,cvcol17);

                 }

            }

            qt_image = QImage((const unsigned char*) (img8bits.data), img10both.cols, img10both.rows, QImage::Format_Grayscale8);
            ui->label10->setPixmap(QPixmap::fromImage(qt_image.scaled(img10both.cols/2,img10both.rows/2, Qt::KeepAspectRatio, Qt::FastTransformation)));
            ui->label10->resize(ui->label10->pixmap()->size());

            minMaxLoc(img17both, &minVal, &maxVal);
            maxVal=280.0; //sinon on ne voit rien
            cv::Mat img8bits17(224,640,CV_8UC1);
            img17both.convertTo(img8bits17,CV_8UC1, 255.0/(maxVal - minVal), -minVal * 255.0/(maxVal - minVal));  //Amélioration contraste

            qt_image17 = QImage((const unsigned char*) (img8bits17.data), img17both.cols, img17both.rows, QImage::Format_Grayscale8);
            ui->label17->setPixmap(QPixmap::fromImage(qt_image17.scaled(img17both.cols,img17both.rows, Qt::KeepAspectRatio, Qt::FastTransformation)));
            ui->label17->resize(ui->label17->pixmap()->size());


            QApplication::processEvents(); //  UTILE OUI

            /********************* Enregistrement - Record - Scan - ... ********************************/

            if(record==1){
                const char* filenamestd10;
                const  char* filenamestd17;
                QString filename10;
                QString filename17;

                if (debut_record==1){
                    QString repertoire0=ui->labelrepertoire->text();
                    QString repertoire1=QDate::currentDate().toString("'DATA_'yyyy_MM_dd");
                    QString repertoire2=QTime::currentTime().toString("'-'HH_mm_ss");

                    repertoire= repertoire0 + QDir::separator() + repertoire1 + repertoire2;

                    QDir dir(repertoire);
                    if (!dir.exists()) {
                        dir.mkpath(".");
                        //  "Création répertoire";
                    }

                    QString filename110=QDate::currentDate().toString("'Fx10_'yyyy_MM_dd");
                    QString filename117=QDate::currentDate().toString("'Fx17_'yyyy_MM_dd");
                    QString filename2=QTime::currentTime().toString("'-'HH_mm_ss'.bin'");

                    filename10=repertoire + QDir::separator()+filename110+filename2;
                    filenamestd10 =filename10.toLocal8Bit().constData();
                    foutapp10=fopen(filenamestd10,"a");
                    int error_code = errno;
                    std::cout << "Errors: " << strerror(error_code) << std::endl;
                    filename17=repertoire + QDir::separator()+filename117+filename2;
                    filenamestd17 =filename17.toLocal8Bit().constData();

                    foutapp17=fopen(filenamestd17,"a");
                    debut_record=0;

                }
                else{ // garder cette structure
                    if(foutapp10 == NULL) {
                        qDebug() << "ici10 1445 =NULL";
                    }
                    else{
                        unsigned int resu;
                        resu = fwrite(img10both.data,sizeof(unsigned short),cvcol10*cvrow10,foutapp10);
                        if (resu!=0){
                            count10++;
                        }
                    }

                    if(foutapp17 == NULL) {
                        qDebug() << " ici17 1456=NULL";
                    }
                    else{
                        unsigned int resu17;
                        resu17=fwrite(img17both.data,sizeof(unsigned short),cvcol17*cvrow17,foutapp17);
                        if (resu17!=0){
                            count17++;
                        }
                    }
                }


            }// fin du if record
            QApplication::processEvents(); //
        }// fin du if (stopFx10!=1)
        else{
            QApplication::processEvents(); //
        }
        QApplication::processEvents(); //
    } // fin du while (!stopFx10 && !stopFx17)
} // FIN de update_windowboth

//https://stackoverflow.com/questions/11563963/writing-a-binary-file-in-c-very-fast



/***********************************************************/
/*                                                         */
/*                    open_dir                             */
/*                                                         */
/***********************************************************/
// change de répertoire
void MainWindow::open_dir()
{
    QString filename1=QDate::currentDate().toString("'darkFx10_'yyyy_MM_dd");
    QString filename2=QTime::currentTime().toString("'-'HH_mm_ss'.bin'");
    QString filename=filename1+filename2;
    std::string filenamestd =filename.toLocal8Bit().constData();
    std::cout <<  filenamestd <<std::endl ;
    QString dirName = QFileDialog::getExistingDirectory(this, tr("Open directory"));
    QByteArray ba = dirName.toLatin1();
    char *c_str2 = ba.data();
    if (strcmp(c_str2,"")!=0){
        qDebug()<< "Dir = " << dirName;
        watcher = new QFileSystemWatcher(this);
        connect(watcher, SIGNAL(directoryChanged(const QString &)), this, SLOT(directoryChanged(const QString &)));
        watcher->addPath(dirName);
        ui->labelrepertoire->setText(dirName);
        QDir dir1(dirName);
        dir1.setPath(dirName);
        //qDebug()<< "Dir path = " << dir1.path();
    }
} // fin open_dir()



/********************************************************************/
/*                                                                  */
/*                  directoryChanged                                */
/*                                                                  */
/********************************************************************/

void MainWindow::directoryChanged(const QString & path)
{
    QDir dir2;
    dir2.setPath(path);
    QApplication::processEvents();
    QThread::sleep(1); // 1 second

} // fin de directoryChanged




/****************************** FERMETURE APPLICATION    *********************************/

// ==> DÉCONNEXION DES CAMÉRAS

/**************************************/
/* closeEvent(QCloseEvent *event) */
/**************************************/

void MainWindow::closeEvent(QCloseEvent *event)
{
    if (cameraFx10.threadPtr) {
        try{
            if  (cameraFx10.running){
                cameraFx10.disconnect();
            }
        }
        catch (std::exception & e){ qFatal("Error %s sending event %s to object ", e.what(), typeid(*event).name());};
    }

    if (cameraFx17.threadPtr) {
        if  (cameraFx17.running){
            cameraFx17.disconnect();
        }
    }
    system("sudo service eBUSd restart");
    emit ui->pushButton_close_webcam->clicked();
    QWidget::closeEvent(event);
    qDebug() << "Fin";
}



MainWindow::~MainWindow()
{
    delete ui;
}
