#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#define EIGEN_STACK_ALLOCATION_LIMIT 0
#include <QMainWindow>
#include "qcustomplot.h"
#include "ui_mainwindow.h"
#include "globalvar.h"
#include <QTimer>
#include <QVector>
#include <opencv2/highgui.hpp>
#include <opencv2/imgproc.hpp>
#include <Eigen/Core>
#include <opencv2/core/eigen.hpp>
#include <QString>
#include <QFile>
#include <QDir>
#include <fstream>
#include <QCloseEvent>
using namespace cv;
#include <iostream>
using namespace std;
#include <limits>
#include <QFileSystemWatcher>
#include"src.h"
namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    QTimer *MyTimer;
    void setupDemo(int demoIndex);
    void setupRealtimeDataDemo(QCustomPlot *customPlot);
    unsigned long index(int x, int y, int taille);
    void update_windowFx10();
    cv::VideoCapture cap;

signals:
    void frameReady(QImage frame);

private slots:
    void on_pushButton_open_webcam_clicked();
    void  NEWrealtimeDataSlot(const Eigen::MatrixXf &vec10);
    void on_pushButton_close_webcam_clicked();
    void update_window();
    void update_windowboth();
    void on_pushButton_close_1017_clicked();
    void closeEvent(QCloseEvent *event);
    void darkcurrent();
    void blanc();
    void closeshutter();
    void openshutter();
    void open_dir();
    void directoryChanged(const QString & path);
    void AffichageSpectre(QCustomPlot *customPlotspectre,unsigned short yb[],unsigned short yv[],unsigned short yr[]);
    void AffichageSpectre17(QCustomPlot *customPlotspectre,unsigned short yb[],unsigned short yv[],unsigned short yr[]);
    void AffichageSignal(QCustomPlot *customPlotspectre,float yb[],float yv[],float yr[]);
    void scan();
    void stop_scan();
    void save_image();
    void essai();
    void cleanup_mat(void* info);

    void mon_slot_slide(const int lapos);

private:
    Ui::MainWindow *ui;
    QTimer *timer;


    Mat frame;
    QImage qt_image;
    QImage qt_imaged;
    QImage qt_imagew10;
    QImage qt_image4;
    QImage qt_image17;
    QImage qt_imaged17;
    QImage qt_imageR;


    Eigen::MatrixXf m;
    QString demoName;
    QTimer dataTimer;
    QCPColorMap *colorMap ;
    QVector<double> Qm;
    QCPColorScale *colorScale ;
    QCustomPlot *customPlot;
    Eigen::MatrixXf dark10;

    cv::Mat1w img10;
    cv::Mat1f img10f;
    cv::Mat1w darkmat;
    int cptdark=0;
    int cptblanc10=0;
    Eigen::MatrixXf DarkEig10;

    cv::Mat accu= cv::Mat::zeros(448,1024, CV_32FC1);
    cv::Mat temp;
    cv::Mat tempraw;
    cv::Mat temp17raw;
    cv::Mat accu16;
    Eigen::MatrixXf somme;


    cv::Mat accu17= cv::Mat::zeros(224,640, CV_32FC1);
    cv::Mat temp17;
    cv::Mat accu1716;
    Eigen::MatrixXf somme17;

    // cv::Mat accublanc10= cv::Mat::ones(448,1024, CV_32FC1);
    //cv::Mat accublanc10= cv::Mat(448,1024, CV_32FC1,cv::Scalar(65000));
    cv::Mat accublanc10= cv::Mat(448,1024, CV_32FC1,cv::Scalar(1));

    cv::Mat accublanc17= cv::Mat(224,640, CV_32FC1,cv::Scalar(1));

    cv::Mat tempblanc10;
    cv::Mat accu16blanc10;
    Eigen::MatrixXf sommeblanc10;

    cv::Mat tempblanc17;
    cv::Mat accu16blanc17;
    Eigen::MatrixXf sommeblanc17;

    QFileSystemWatcher * watcher;

    Eigen::MatrixXf vec10= Eigen::MatrixXf::Zero(1024,1);

    //const char* filenamestd10;
    //const  char* filenamestd17;
    //QString filename10;
    //QString filename17;
    FILE*  foutapp10;
    FILE*  foutapp17;
    int count10;
    int count17;

    QString repertoire;

    cv::Mat img;
    // Eigen::MatrixXi STOCKAGE=Eigen::MatrixXi::Zero(2000,1024);
    //Eigen::Matrix<unsigned char,Eigen::Dynamic,Eigen::Dynamic> STOCKAGE;//= Eigen::Matrix<unsigned char,Eigen::Dynamic,Eigen::Dynamic>::Zero(2000,cvrow10);
    //Eigen::Matrix<unsigned char,Eigen::Dynamic,Eigen::Dynamic> STOCKAGE;
    //STOCKAGE= Eigen::Matrix<unsigned char,Eigen::Dynamic,Eigen::Dynamic>::Zero(2000,cvrow10);
    //CaptureHandler(cv::VideoCapture* vc);
    QTimer *ttt;


};

#endif // MAINWINDOW_H
